# Jetpack-Compose-Sample
Sample project in Kotlin to demonstrate Jetpack Compose, MVVM, Coroutines, Hilt, Room, Coil, Retrofit, Moshi, Leak Canary and Repository pattern

## The app has the following base packages:

- database: Room database classes

- di: Hilt classes for Network and Database

- domain: Models used by UI

- network: Api interfaces and models

- repository: Repositories

- ui: UI components along with ViewModels

- util: Utility classes

## Library reference resources:

- MVVM Architecture : https://developer.android.com/jetpack/guide

- Hilt: https://developer.android.com/training/dependency-injection/hilt-android

- Coroutines: https://developer.android.com/kotlin/coroutines

- Retrofit: https://square.github.io/retrofit/

- Moshi: https://github.com/square/moshi

- Coil: https://coil-kt.github.io/coil/

- Leak Canary: https://square.github.io/leakcanary/

## Concept reference resources:

- Repository Codelab: https://developer.android.com/codelabs/kotlin-android-training-repository

- Room and Coroutines Codelab: https://developer.android.com/codelabs/kotlin-android-training-room-database

- Room and Flow Codelab: https://developer.android.com/codelabs/basic-android-kotlin-training-intro-room-flow

- Hilt Codelab: https://developer.android.com/codelabs/android-hilt

- Navigation Codelab: https://developer.android.com/codelabs/jetpack-compose-navigation

- Theming Codelab: https://developer.android.com/codelabs/jetpack-compose-theming

- Basic Layouts Codelab: https://developer.android.com/codelabs/jetpack-compose-layouts